#pragma once

#include "Status.h"

class Stream;

namespace httpsserver
{
	class HTTPRequest;
	class HTTPResponse;
}

namespace detail
{
	class WebServer
	{
	public:
		WebServer();
		~WebServer();

		void begin();

		void setStatus(const Status& status);

	private:
		static void ServerTask_(void* params);
		static void HandleIndex_(httpsserver::HTTPRequest * request, httpsserver::HTTPResponse * response);
		static void HandleGetStatus_(httpsserver::HTTPRequest * request, httpsserver::HTTPResponse * response);
		static void HandlePostInfo_(httpsserver::HTTPRequest * request, httpsserver::HTTPResponse * response);
		static void HandleDefault_(httpsserver::HTTPRequest * request, httpsserver::HTTPResponse * response);

		static void SendContent_(Stream& stream, httpsserver::HTTPResponse * response);

	private:
		Status status_;
	};
}

extern detail::WebServer WebServer;
